Index: LMDZ5/trunk/libf/phylmd/cosp/radar_simulator_types.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/radar_simulator_types.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/radar_simulator_types.F90	(revision 2428)
@@ -3,20 +3,30 @@
 ! Collection of common variables and types
 ! Part of QuickBeam v1.03 by John Haynes
-! http://reef.atmos.colostate.edu/haynes/radarsim
+! Updated by Roj Marchand June 2010 
 
   integer, parameter ::       &
-  maxhclass = 20 	     ,& ! max number of hydrometeor classes
-  nd = 85		     ,& ! number of discrete particles  
-  nRe_types = 250		! number or Re size bins allowed in N and Z_scaled look up table
+  maxhclass = 20         ,& ! max number of hydrometeor classes
+  nRe_types = 550       ! max number or Re size bins allowed in N and Z_scaled look up table
 
+  ! These variables define discrete diameters used to represent the DSDs.
+  integer, parameter ::       &
+  nd = 85               ! number of discrete particles used in construction DSDs
   real*8, parameter ::        &
   dmin = 0.1                 ,& ! min size of discrete particle
-  dmax = 10000.                	! max size of discrete particle
+  dmax = 10000.                 ! max size of discrete particle
    
-  integer, parameter :: &
+  integer, parameter :: &   ! These parameters used to define temperature intervals in mie LUTs
   mt_nfreq = 5              , &
-  mt_ntt = 39               , &	! num temperatures in table
-  mt_nf	= 14		    , &	! number of ice fractions in table  
-  mt_nd = 85                   ! num discrete mode-p drop sizes in table
+  mt_ntt = 39               , & ! num temperatures in table
+  mt_nf = 14            , & ! number of ice fractions in table  
+  mt_nd = 85                    ! num discrete mode-p drop sizes in table
+
+  integer, parameter :: &   ! These parameters used to defines Re intervals in scale LUTs
+  Re_BIN_LENGTH=10, &        
+  Re_MAX_BIN=250
+
+  integer, parameter :: &   ! These parameters used to define Temperature invervals in scale LUTs
+  cnt_liq = 19, &       ! liquid temperature count
+  cnt_ice = 20          ! ice temperature count
 
 
@@ -24,32 +34,41 @@
   
   type class_param
+  
+    ! variables used to store hydrometeor "default" properties
     real*8,  dimension(maxhclass) :: p1,p2,p3,dmin,dmax,apm,bpm,rho
     integer, dimension(maxhclass) :: dtype,col,cp,phase
-    logical, dimension(maxhclass,nRe_types) :: scaled
-    logical, dimension(maxhclass,mt_ntt,nRe_types) :: z_flag
+  
+    ! Radar properties
+    real*8  :: freq,k2
+    integer :: nhclass      ! number of hydrometeor classes in use
+    integer :: use_gas_abs, do_ray
+    
+    ! defines location of radar relative to hgt_matrix.   
+    logical :: radar_at_layer_one	! if true radar is assume to be at the edge 
+    					! of the first layer, if the first layer is the
+    					! surface than a ground-based radar.   If the
+    					! first layer is the top-of-atmosphere, then
+    					! a space borne radar. 
+    
+    ! variables used to store Z scale factors
+    character*240 :: scale_LUT_file_name
+    logical :: load_scale_LUTs, update_scale_LUTs
+    logical, dimension(maxhclass,nRe_types) :: N_scale_flag
+    logical, dimension(maxhclass,mt_ntt,nRe_types) :: Z_scale_flag,Z_scale_added_flag
     real*8,  dimension(maxhclass,mt_ntt,nRe_types) :: Ze_scaled,Zr_scaled,kr_scaled
     real*8,  dimension(maxhclass,nd,nRe_types) :: fc, rho_eff
-    integer, dimension(maxhclass,nd,nRe_types) :: ifc
-    integer, dimension(maxhclass) :: idd
+
+    ! used to determine Re index
+    real*8  :: step_list(Re_MAX_BIN),base_list(Re_MAX_BIN)
+  
+    ! used to determine temperature index
+    real*8 :: &
+        mt_ttl(cnt_liq), &  ! liquid temperatures (K)
+        mt_tti(cnt_ice)     ! ice temperatures (K)
+
+    real*8 :: D(nd) ! set of discrete diameters used to represent DSDs
+
   end type class_param
-
-! ----- mie table structure -----
   
-  type mie
-    real*8 :: freq(mt_nfreq), tt(mt_ntt), f(mt_nf), D(mt_nd)
-    real*8, dimension(mt_nd,mt_ntt,mt_nf,mt_nfreq) :: qext, qbsca
-    integer :: phase(mt_ntt)
-  end type mie
-
-  real*8, dimension(:), save, allocatable :: &
-    mt_ttl, &			! liquid temperatures (C)
-    mt_tti, &			! ice temperatures (C)
-    mt_qext, mt_qbsca		! extincion/backscatter efficiency
-!$OMP THREADPRIVATE(mt_ttl,mt_tti,mt_qext, mt_qbsca)
-
-  integer*4,save :: &
-    cnt_liq, &			! liquid temperature count
-    cnt_ice			! ice temperature count
-!$OMP THREADPRIVATE(cnt_liq,cnt_ice)
-
+   
   end module radar_simulator_types
Index: LMDZ5/trunk/libf/phylmd/cosp/read_cosp_output_nl.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/read_cosp_output_nl.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/read_cosp_output_nl.F90	(revision 2428)
@@ -11,18 +11,52 @@
   integer :: i
 
-  logical, save ::   Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim, &
-             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,Lcfad_dbze94, &
-             Lcfad_lidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp2,Lcllcalipso, &
-             Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lctpisccp,Ldbze94,Ltauisccp,Ltclisccp, &
-             Llongitude,Llatitude,Lparasol_refl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
-             Lfrac_out,Lbeta_mol532,Ltbrttov
-
-  namelist/COSP_OUTPUT/Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim, &
-             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,Lcfad_dbze94, &
-             Lcfad_lidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp2, &
-             Lcllcalipso,Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lctpisccp,Ldbze94,Ltauisccp, &
-             Ltclisccp,Llongitude,Llatitude,Lparasol_refl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
-             Lfrac_out,Lbeta_mol532,Ltbrttov
-
+!! AI 
+!  logical, save ::   Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim, &
+!             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,Lcfad_dbze94, &
+!             Lcfad_lidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp2,Lcllcalipso, &
+!             Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lctpisccp,Ldbze94,Ltauisccp,Ltclisccp, &
+!             Llongitude,Llatitude,Lparasol_refl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
+!             Lfrac_out,Lbeta_mol532,Ltbrttov
+
+!  namelist/COSP_OUTPUT/Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim, &
+!             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,Lcfad_dbze94, &
+!             Lcfad_lidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp2, &
+!             Lcllcalipso,Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lctpisccp,Ldbze94,Ltauisccp, &
+!             Ltclisccp,Llongitude,Llatitude,Lparasol_refl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
+!             Lfrac_out,Lbeta_mol532,Ltbrttov
+!!
+
+ logical, save :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
+             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
+             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp,Lcllcalipso, &
+             Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp,Lcltisccp, &
+             Lclcalipsoliq,Lclcalipsoice,Lclcalipsoun, &
+             Lclcalipsotmp,Lclcalipsotmpliq,Lclcalipsotmpice,Lclcalipsotmpun, &
+             Lcltcalipsoliq,Lcltcalipsoice,Lcltcalipsoun, &
+             Lclhcalipsoliq,Lclhcalipsoice,Lclhcalipsoun, &
+             Lclmcalipsoliq,Lclmcalipsoice,Lclmcalipsoun, &
+             Lcllcalipsoliq,Lcllcalipsoice,Lcllcalipsoun, &
+             Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
+             Lfracout,LlidarBetaMol532,Ltbrttov, &
+             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
+             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
+             Liwpmodis,Lclmodis
+
+  namelist/COSP_OUTPUT/Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
+             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
+             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp, &
+             Lcllcalipso,Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp, &
+             Lclcalipsoliq,Lclcalipsoice,Lclcalipsoun, &
+             Lclcalipsotmp,Lclcalipsotmpliq,Lclcalipsotmpice,Lclcalipsotmpun, &
+             Lcltcalipsoliq,Lcltcalipsoice,Lcltcalipsoun, &
+             Lclhcalipsoliq,Lclhcalipsoice,Lclhcalipsoun, &
+             Lclmcalipsoliq,Lclmcalipsoice,Lclmcalipsoun, &
+             Lcllcalipsoliq,Lcllcalipsoice,Lcllcalipsoun, &
+             Lcltisccp,Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
+             Lfracout,LlidarBetaMol532,Ltbrttov, &
+             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
+             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
+             Liwpmodis,Lclmodis
+   
   do i=1,N_OUT_LIST
     cfg%out_list(i)=''
@@ -38,4 +72,5 @@
   CALL bcast(Llidar_sim)
   CALL bcast(Lisccp_sim)
+  CALL bcast(Lmodis_sim)
   CALL bcast(Lmisr_sim)
   CALL bcast(Lrttov_sim)
@@ -49,4 +84,23 @@
   CALL bcast(Lclcalipso)
   CALL bcast(Lclhcalipso)
+  CALL bcast(Lclcalipsoliq)
+  CALL bcast(Lclcalipsoice)
+  CALL bcast(Lclcalipsoun)
+  CALL bcast(Lclcalipsotmp)
+  CALL bcast(Lclcalipsotmpliq)
+  CALL bcast(Lclcalipsotmpice)
+  CALL bcast(Lclcalipsotmpun)
+  CALL bcast(Lcltcalipsoliq)
+  CALL bcast(Lcltcalipsoice)
+  CALL bcast(Lcltcalipsoun)
+  CALL bcast(Lclhcalipsoliq)
+  CALL bcast(Lclhcalipsoice)
+  CALL bcast(Lclhcalipsoun)
+  CALL bcast(Lclmcalipsoliq)
+  CALL bcast(Lclmcalipsoice)
+  CALL bcast(Lclmcalipsoun)
+  CALL bcast(Lcllcalipsoliq)
+  CALL bcast(Lcllcalipsoice) 
+  CALL bcast(Lcllcalipsoun)
   CALL bcast(Lclisccp2)
   CALL bcast(Lcllcalipso)
@@ -57,7 +111,5 @@
   CALL bcast(Ldbze94)
   CALL bcast(Ltauisccp)
-  CALL bcast(Ltclisccp)
-  CALL bcast(Llongitude)
-  CALL bcast(Llatitude)
+  CALL bcast(Lcltisccp)
   CALL bcast(Lparasol_refl)
   CALL bcast(LclMISR)
@@ -66,4 +118,22 @@
   CALL bcast(Lfrac_out)
   CALL bcast(Lbeta_mol532)
+  CALL bcast(Lcltmodis)
+  CALL bcast(Lclwmodis)
+  CALL bcast(Lclimodis) 
+  CALL bcast(Lclhmodis)
+  CALL bcast(Lclmmodis)
+  CALL bcast(Lcllmodis)
+  CALL bcast(Ltautmodis)
+  CALL bcast(Ltauwmodis)
+  CALL bcast(Ltauimodis)
+  CALL bcast(Ltautlogmodis)
+  CALL bcast(Ltauwlogmodis)
+  CALL bcast(Ltauilogmodis)
+  CALL bcast(Lreffclwmodis)
+  CALL bcast(Lreffclimodis)
+  CALL bcast(Lpctmodis)
+  CALL bcast(Llwpmodis)
+  CALL bcast(Liwpmodis)
+  CALL bcast(Lclmodis)
   CALL bcast(Ltbrttov)
 !$OMP BARRIER
@@ -92,4 +162,24 @@
     Lparasol_refl    = .false.
     Lbeta_mol532     = .false.
+!! AI
+    Lclcalipsoliq    = .false.
+    Lclcalipsoice    = .false.
+    Lclcalipsoun    = .false.
+    Lclcalipsotmp    = .false.
+    Lclcalipsotmpun    = .false.
+    Lclcalipsotmpliq    = .false.
+    Lclcalipsotmpice    = .false.
+    Lclhcalipsoliq      = .false.
+    Lcllcalipsoliq      = .false.
+    Lclmcalipsoliq     = .false.
+    Lcltcalipsoliq      = .false.
+    Lclhcalipsoice      = .false.
+    Lcllcalipsoice      = .false.
+    Lclmcalipsoice      = .false.
+    Lcltcalipsoice      = .false.
+    Lclhcalipsoun      = .false.
+    Lcllcalipsoun      = .false.
+    Lclmcalipsoun      = .false.
+    Lcltcalipsoun      = .false.
   endif
   if (.not.Lisccp_sim) then
@@ -114,4 +204,25 @@
     Lfrac_out = .false.
   endif
+ if (.not.Lmodis_sim) then
+    Lcltmodis=.false.
+    Lclwmodis=.false.
+    Lclimodis=.false.
+    Lclhmodis=.false.
+    Lclmmodis=.false.
+    Lcllmodis=.false.
+    Ltautmodis=.false.
+    Ltauwmodis=.false.
+    Ltauimodis=.false.
+    Ltautlogmodis=.false.
+    Ltauwlogmodis=.false.
+    Ltauilogmodis=.false.
+    Lreffclwmodis=.false.
+    Lreffclimodis=.false.
+    Lpctmodis=.false.
+    Llwpmodis=.false.
+    Liwpmodis=.false.
+    Lclmodis=.false.
+  endif
+  if (Lmodis_sim) Lisccp_sim = .true.
 
   ! Diagnostics that use Radar and Lidar
@@ -130,4 +241,5 @@
   cfg%Llidar_sim = Llidar_sim
   cfg%Lisccp_sim = Lisccp_sim
+  cfg%Lmodis_sim = Lmodis_sim
   cfg%Lmisr_sim  = Lmisr_sim
   cfg%Lrttov_sim = Lrttov_sim
@@ -149,7 +261,7 @@
   if (Lboxtauisccp)     cfg%out_list(i) = 'boxtauisccp'
   i = i+1
-  if (Lcfad_dbze94)     cfg%out_list(i) = 'cfad_dbze94'
-  i = i+1
-  if (Lcfad_lidarsr532) cfg%out_list(i) = 'cfad_lidarsr532'
+  if (LcfadDbze94)      cfg%out_list(i) = 'cfadDbze94'
+  i = i+1
+  if (LcfadLidarsr532)  cfg%out_list(i) = 'cfadLidarsr532'
   i = i+1
   if (Lclcalipso2)      cfg%out_list(i) = 'clcalipso2'
@@ -159,5 +271,5 @@
   if (Lclhcalipso)      cfg%out_list(i) = 'clhcalipso'
   i = i+1
-  if (Lclisccp2)        cfg%out_list(i) = 'clisccp2'
+  if (Lclisccp)         cfg%out_list(i) = 'clisccp'
   i = i+1
   if (Lcllcalipso)      cfg%out_list(i) = 'cllcalipso'
@@ -167,7 +279,48 @@
   if (Lcltcalipso)      cfg%out_list(i) = 'cltcalipso'
   i = i+1
+
+  if (Lcllcalipsoice)      cfg%out_list(i) = 'cllcalipsoice'
+  i = i+1
+  if (Lclmcalipsoice)      cfg%out_list(i) = 'clmcalipsoice'
+  i = i+1
+  if (Lclhcalipsoice)      cfg%out_list(i) = 'clhcalipsoice'
+  i = i+1
+  if (Lcltcalipsoice)      cfg%out_list(i) = 'cltcalipsoice'
+  i = i+1
+  if (Lcllcalipsoliq)      cfg%out_list(i) = 'cllcalipsoliq'
+  i = i+1
+  if (Lclmcalipsoliq)      cfg%out_list(i) = 'clmcalipsoliq'
+  i = i+1
+  if (Lclhcalipsoliq)      cfg%out_list(i) = 'clhcalipsoliq'
+  i = i+1
+  if (Lcltcalipsoliq)      cfg%out_list(i) = 'cltcalipsoliq'
+  i = i+1
+  if (Lcllcalipsoun)      cfg%out_list(i) = 'cllcalipsoun'
+  i = i+1
+  if (Lclmcalipsoun)      cfg%out_list(i) = 'clmcalipsoun'
+  i = i+1
+  if (Lclhcalipsoun)      cfg%out_list(i) = 'clhcalipsoun'
+  i = i+1
+  if (Lcltcalipsoun)      cfg%out_list(i) = 'cltcalipsoun'
+  i = i+1
+
+  if (Lclcalipsoice)       cfg%out_list(i) = 'clcalipsoice'
+  i = i+1
+  if (Lclcalipsoliq)       cfg%out_list(i) = 'clcalipsoliq'
+  i = i+1
+  if (Lclcalipsoun)       cfg%out_list(i) = 'clcalipsoun'
+  i = i+1
+
+  if (Lclcalipsotmp)       cfg%out_list(i) = 'clcalipsotmp'
+  i = i+1
+  if (Lclcalipsotmpice)       cfg%out_list(i) = 'clcalipsotmpice'
+  i = i+1
+  if (Lclcalipsotmpliq)       cfg%out_list(i) = 'clcalipsotmpliq'
+  i = i+1
+  if (Lclcalipsotmpun)       cfg%out_list(i) = 'clcalipsotmpun'
+  i = i+1
   if (Lcltlidarradar)   cfg%out_list(i) = 'cltlidarradar'
   i = i+1
-  if (Lctpisccp)        cfg%out_list(i) = 'ctpisccp'
+  if (Lpctisccp)        cfg%out_list(i) = 'pctisccp'
   i = i+1
   if (Ldbze94)          cfg%out_list(i) = 'dbze94'
@@ -175,11 +328,9 @@
   if (Ltauisccp)        cfg%out_list(i) = 'tauisccp'
   i = i+1
-  if (Ltclisccp)        cfg%out_list(i) = 'tclisccp'
-  i = i+1
-  if (Llongitude)       cfg%out_list(i) = 'lon'
-  i = i+1
-  if (Llatitude)        cfg%out_list(i) = 'lat'
-  i = i+1
-  if (Lparasol_refl)    cfg%out_list(i) = 'parasol_refl'
+  if (Lcltisccp)        cfg%out_list(i) = 'cltisccp'
+  i = i+1
+  if (Ltoffset)         cfg%out_list(i) = 'toffset'
+  i = i+1
+  if (LparasolRefl)     cfg%out_list(i) = 'parasolRefl'
   i = i+1
   if (LclMISR)          cfg%out_list(i) = 'clMISR'
@@ -189,44 +340,124 @@
   if (Lmeantbclrisccp)  cfg%out_list(i) = 'meantbclrisccp'
   i = i+1
-  if (Lfrac_out)        cfg%out_list(i) = 'frac_out'
-  i = i+1
-  if (Lbeta_mol532)     cfg%out_list(i) = 'beta_mol532'
+  if (Lfracout)         cfg%out_list(i) = 'fracout'
+  i = i+1
+  if (LlidarBetaMol532) cfg%out_list(i) = 'lidarBetaMol532'
   i = i+1
   if (Ltbrttov)         cfg%out_list(i) = 'tbrttov'
-
+  i = i+1
+  if (Lcltmodis)        cfg%out_list(i) = 'cltmodis'
+  i = i+1
+  if (Lclwmodis)        cfg%out_list(i) = 'clwmodis'
+  i = i+1
+  if (Lclimodis)        cfg%out_list(i) = 'climodis'
+  i = i+1
+  if (Lclhmodis)        cfg%out_list(i) = 'clhmodis'
+  i = i+1
+  if (Lclmmodis)        cfg%out_list(i) = 'clmmodis'
+  i = i+1
+  if (Lcllmodis)        cfg%out_list(i) = 'cllmodis'
+  i = i+1
+  if (Ltautmodis)       cfg%out_list(i) = 'tautmodis'
+  i = i+1
+  if (Ltauwmodis)       cfg%out_list(i) = 'tauwmodis'
+  i = i+1
+  if (Ltauimodis)       cfg%out_list(i) = 'tauimodis'
+  i = i+1
+  if (Ltautlogmodis)    cfg%out_list(i) = 'tautlogmodis'
+  i = i+1
+  if (Ltauwlogmodis)    cfg%out_list(i) = 'tauwlogmodis'
+  i = i+1
+  if (Ltauilogmodis)    cfg%out_list(i) = 'tauilogmodis'
+  i = i+1
+  if (Lreffclwmodis)    cfg%out_list(i) = 'reffclwmodis'
+  i = i+1
+  if (Lreffclimodis)    cfg%out_list(i) = 'reffclimodis'
+  i = i+1
+  if (Lpctmodis)        cfg%out_list(i) = 'pctmodis'
+  i = i+1
+  if (Llwpmodis)        cfg%out_list(i) = 'lwpmodis'
+  i = i+1
+  if (Liwpmodis)        cfg%out_list(i) = 'iwpmodis'
+  i = i+1
+  if (Lclmodis)         cfg%out_list(i) = 'clmodis'
+    
   if (i /= N_OUT_LIST) then
      print *, 'COSP_IO: wrong number of output diagnostics'
+     print *, i,N_OUT_LIST
      stop
   endif
 
   ! Copy diagnostic flags to cfg structure
+  ! ISCCP simulator  
   cfg%Lalbisccp = Lalbisccp
   cfg%Latb532 = Latb532
   cfg%Lboxptopisccp = Lboxptopisccp
   cfg%Lboxtauisccp = Lboxtauisccp
-  cfg%Lcfad_dbze94 = Lcfad_dbze94
-  cfg%Lcfad_lidarsr532 = Lcfad_lidarsr532
+  cfg%Lmeantbisccp = Lmeantbisccp
+  cfg%Lmeantbclrisccp = Lmeantbclrisccp
+  cfg%Lclisccp = Lclisccp
+  cfg%Lpctisccp = Lpctisccp
+  cfg%Ltauisccp = Ltauisccp
+  cfg%Lcltisccp = Lcltisccp
+  ! CloudSat simulator  
+  cfg%Ldbze94 = Ldbze94
+  cfg%LcfadDbze94 = LcfadDbze94
+  ! CALIPSO/PARASOL simulator  
+  cfg%LcfadLidarsr532 = LcfadLidarsr532
   cfg%Lclcalipso2 = Lclcalipso2
   cfg%Lclcalipso = Lclcalipso
   cfg%Lclhcalipso = Lclhcalipso
-  cfg%Lclisccp2 = Lclisccp2
   cfg%Lcllcalipso = Lcllcalipso
   cfg%Lclmcalipso = Lclmcalipso
   cfg%Lcltcalipso = Lcltcalipso
+  cfg%Lclhcalipsoice = Lclhcalipsoice
+  cfg%Lcllcalipsoice = Lcllcalipsoice
+  cfg%Lclmcalipsoice = Lclmcalipsoice
+  cfg%Lcltcalipsoice = Lcltcalipsoice
+  cfg%Lclhcalipsoliq = Lclhcalipsoliq
+  cfg%Lcllcalipsoliq = Lcllcalipsoliq
+  cfg%Lclmcalipsoliq = Lclmcalipsoliq
+  cfg%Lcltcalipsoliq = Lcltcalipsoliq
+  cfg%Lclhcalipsoun = Lclhcalipsoun
+  cfg%Lcllcalipsoun = Lcllcalipsoun
+  cfg%Lclmcalipsoun = Lclmcalipsoun
+  cfg%Lcltcalipsoun = Lcltcalipsoun
+  cfg%Lclcalipsoice = Lclcalipsoice
+  cfg%Lclcalipsoliq = Lclcalipsoliq
+  cfg%Lclcalipsoun = Lclcalipsoun
+  cfg%Lclcalipsotmp = Lclcalipsotmp
+  cfg%Lclcalipsotmpice = Lclcalipsotmpice
+  cfg%Lclcalipsotmpliq = Lclcalipsotmpliq
+  cfg%Lclcalipsotmpun = Lclcalipsotmpun
   cfg%Lcltlidarradar = Lcltlidarradar
-  cfg%Lctpisccp = Lctpisccp
-  cfg%Ldbze94 = Ldbze94
-  cfg%Ltauisccp = Ltauisccp
-  cfg%Ltclisccp = Ltclisccp
-  cfg%Llongitude = Llongitude
-  cfg%Llatitude = Llatitude
-  cfg%Lparasol_refl = Lparasol_refl
+  cfg%LparasolRefl = LparasolRefl
+  ! MISR simulator  
   cfg%LclMISR = LclMISR
-  cfg%Lmeantbisccp = Lmeantbisccp
-  cfg%Lmeantbclrisccp = Lmeantbclrisccp
-  cfg%Lfrac_out = Lfrac_out
-  cfg%Lbeta_mol532 = Lbeta_mol532
+  ! Other
+  cfg%Ltoffset = Ltoffset
+  cfg%Lfracout = Lfracout
+  cfg%LlidarBetaMol532 = LlidarBetaMol532
+  ! RTTOV
   cfg%Ltbrttov = Ltbrttov
-
+  ! MODIS simulator  
+  cfg%Lcltmodis=Lcltmodis
+  cfg%Lclwmodis=Lclwmodis
+  cfg%Lclimodis=Lclimodis
+  cfg%Lclhmodis=Lclhmodis
+  cfg%Lclmmodis=Lclmmodis
+  cfg%Lcllmodis=Lcllmodis
+  cfg%Ltautmodis=Ltautmodis
+  cfg%Ltauwmodis=Ltauwmodis
+  cfg%Ltauimodis=Ltauimodis
+  cfg%Ltautlogmodis=Ltautlogmodis
+  cfg%Ltauwlogmodis=Ltauwlogmodis
+  cfg%Ltauilogmodis=Ltauilogmodis
+  cfg%Lreffclwmodis=Lreffclwmodis
+  cfg%Lreffclimodis=Lreffclimodis
+  cfg%Lpctmodis=Lpctmodis
+  cfg%Llwpmodis=Llwpmodis
+  cfg%Liwpmodis=Liwpmodis
+  cfg%Lclmodis=Lclmodis
+  
  END SUBROUTINE READ_COSP_OUTPUT_NL
 
Index: LMDZ5/trunk/libf/phylmd/cosp/scops.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/scops.F	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/scops.F	(revision 2428)
@@ -6,4 +6,6 @@
 ! (c) British Crown Copyright 2009, the Met Office.
 ! All rights reserved.
+! $Revision: 23 $, $Date: 2011-03-31 15:41:37 +0200 (jeu. 31 mars 2011) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/scops.f $
 ! 
 ! Redistribution and use in source and binary forms, with or without 
@@ -39,7 +41,4 @@
 ! *****************************COPYRIGHT*******************************
 
-      USE mod_phys_lmdz_para
-      USE mod_grid_phy_lmdz
-
       implicit none
 
@@ -178,6 +177,5 @@
           ELSE
               DO ibox=1,ncol
-!                include 'congvec_para.h'
-                 include 'congvec.h'
+                include 'congvec.h'
                 ! select random pixels from the non-convective
                 ! part the gridbox ( some will be converted into
@@ -209,7 +207,7 @@
           do j=1,npoints
             if (boxpos(j,ibox).le.conv(j,ilev)) then
-              maxocc(j,ibox) = 1.
+              maxocc(j,ibox) = 1
             else
-              maxocc(j,ibox) = 0.
+              maxocc(j,ibox) = 0
             end if
           enddo
Index: LMDZ5/trunk/libf/phylmd/cosp/zeff.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/zeff.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/zeff.F90	(revision 2428)
@@ -1,2 +1,4 @@
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/quickbeam/zeff.f90 $
   subroutine zeff(freq,D,N,nsizes,k2,tt,ice,xr,z_eff,z_ray,kr,qe,qs,rho_e)
   use math_lib
@@ -15,5 +17,5 @@
 !   [nsizes]    number of discrete drop sizes
 !   [k2]        |K|^2, -1=use frequency dependent default 
-!   [tt]        hydrometeor temperature (C)
+!   [tt]        hydrometeor temperature (K)
 !   [ice]       indicates volume consists of ice
 !   [xr]        perform Rayleigh calculations?
@@ -42,25 +44,26 @@
 ! ----- INTERNAL -----
   integer :: &
-  correct_for_rho		! correct for density flag
+  correct_for_rho        ! correct for density flag
   real*8, dimension(nsizes) :: &
-  D0, &				! D in (m)
-  N0, &				! N in m^-3 m^-1
-  sizep, &			! size parameter
-  qext, &			! extinction efficiency
-  qbsca, &			! backscatter efficiency
-  rho_ice, &			! bulk density ice (kg m^-3)
-  f				! ice fraction
+  D0, &                  ! D in (m)
+  N0, &                  ! N in m^-3 m^-1
+  sizep, &               ! size parameter
+  qext, &           ! extinction efficiency
+  qbsca, &               ! backscatter efficiency
+  rho_ice, &             ! bulk density ice (kg m^-3)
+  f                 ! ice fraction
+  real*8, dimension(nsizes) :: xtemp
   real*8 :: &
-  wl, &				! wavelength (m)
+  wl, &                  ! wavelength (m)
   cr                            ! kr(dB/km) = cr * kr(1/km)
   complex*16 :: &
-  m				! complex index of refraction of bulk form
+  m                 ! complex index of refraction of bulk form
   complex*16, dimension(nsizes) :: &
-  m0				! complex index of refraction
+  m0                ! complex index of refraction
   
   integer*4 :: i,one
   real*8 :: pi
   real*8 :: eta_sum, eta_mie, const, z0_eff, z0_ray, k_sum, &
-            n_r, n_i, dqv(1), dqxt, dqsc, dbsc, dg, dph(1)
+            n_r, n_i, dqv(1), dqsc, dg, dph(1)
   integer*4 :: err
   complex*16 :: Xs1(1), Xs2(1)
@@ -72,7 +75,7 @@
 
 ! // conversions
-  D0 = d*1E-6			! m
-  N0 = n*1E12			! 1/(m^3 m)
-  wl = 2.99792458/(freq*10)	! m
+  D0 = d*1E-6            ! m
+  N0 = n*1E12            ! 1/(m^3 m)
+  wl = 2.99792458/(freq*10)   ! m
   
 ! // dielectric constant |k^2| defaults
@@ -127,5 +130,6 @@
     eta_sum = qbsca(1)*(n(1)*1E6)*D0(1)**2
   else
-    call avint(qbsca*N0*D0**2,D0,nsizes,D0(1),D0(size(D0,1)),eta_sum)
+    xtemp = qbsca*N0*D0**2
+    call avint(xtemp,D0,nsizes,D0(1),D0(size(D0,1)),eta_sum)
   endif
  
@@ -140,9 +144,10 @@
     k_sum = qext(1)*(n(1)*1E6)*D0(1)**2
   else
-    call avint(qext*N0*D0**2,D0,nsizes,D0(1),D0(size(D0,1)),k_sum)
+    xtemp = qext*N0*D0**2
+    call avint(xtemp,D0,nsizes,D0(1),D0(size(D0,1)),k_sum)
   endif
   cr = 10./log(10.)
   kr = k_sum*0.25*pi*(1000.*cr)
-	
+     
 ! // z_ray = sum[D^6*N(D)*deltaD]
   if (xr == 1) then
@@ -151,5 +156,6 @@
       z0_ray = (n(1)*1E6)*D0(1)**6
     else
-      call avint(N0*D0**6,D0,nsizes,D0(1),D0(size(D0)),z0_ray)
+      xtemp = N0*D0**6
+      call avint(xtemp,D0,nsizes,D0(1),D0(size(D0)),z0_ray)
     endif
   endif
